100 ::
110 CLEAR: REMark ContourDemo3_bas INTERPOLATION by S.Poole v30nov92, v7oct24
120 REMark Just LRUN. (Hit 'n' to repeat a curve when paused).
125 RANDOMISE DATE
130 dotss=10: prec=16: REMark Change the number of dots or the precision....
140 pr=0: IF pr: prec=8
150 :
160 REPeat LOOP
170 IF dotss<4: dotss=4: END IF : IF dotss>90: dotss=90
180 pmf=prec MOD 4: IF pmf: prec=prec-pmf
190 IF prec<4: prec=4: END IF : IF prec>40: prec=40
200 INIT: INK 7
210 TYPEM: DRAW: IF INKEY$(250)=='n': GO TO 210
220 END REPeat LOOP
230 :
240 DEFine PROCedure TYPEM
250 INK 4: oaz=0
260 REMark loop to calculate each bearing :
270 FOR f=1 TO dots+3
280 j=f+1: fj=j
290 xx=t(j,x)-t(f,x): yy=t(j,y)-t(f,y)
300 dd=SQRT(xx*xx+yy*yy)
310 sx=(xx>0)-(xx<0): sy=(yy>0)-(yy<0): IF dd=0: az=0: ELSE : az=ASIN(yy/dd): END IF
320 IF sx>=0: IF sy<0: az=Pww+az: END IF : ELSE : az=PI-az: END IF
330 IF (ABS(az)==RAD(45)) OR (0==(ABS(az)+1)) OR (oaz==az): t(j,y)=t(j,y)+1:::: GO TO 290: END IF
340 t(f,azt)=az: oaz=az
350 END FOR f
360 :
370 REMark loop to detect 'straight_ish' lines :
380 DIM pic(0),pic(dots+5,2)
390 FOR f=1 TO dots-2
400 az1=t(f,azt): az2=t(f+1,azt): az3=t(f+2,azt)
410 az4=t(f+3,azt): a5=RAD(15): za1=0: za2=0
420 SELect az1: =az2-a5 TO az2+a5: za1=1: pic(f+1,1)=2
430 SELect az3: =az4-a5 TO az4+a5: za2=1: pic(f+2,1)=3
440 IF za1 OR za2 THEN
450 REMark INK 7: CIRCLE t(f,x),t(f,y),2: INK 4
460 END IF
470 END FOR f
480 :
490 REMark Loop to Keep bearings in 'whole circle':
500 FOR f=2 TO dots+3
510 th=t(f,azt)-t(f-1,azt): IF th<-PI: th=th+Pww
520 IF th>PI: th=th-Pww
530 t(f,trn)=th
540 END FOR f: t(1,trn)=t(dots+1,trn)
550 :
560 REMark Loop to get the signs of the bearings :
570 FOR f=1 TO dots+3
580 t1=t(f,trn): t2=t(f+1,trn): s1=(t1>0)-(t1<0): s2=(t2>0)-(t2<0)
590 s$=sig$(s1+2)&sig$(s2+2)&' ': tp=s$ INSTR sg$
600 t(f,typ)=((tp+2)/3)-1
610 END FOR f: t(dots+4,typ)=t(4,typ)
620 END DEFine TYPEM
630 :
640 DEFine PROCedure DRAW
650 DIM TRg(0),TRg(dots+4)
660 REMark Loop to Consider the triangles linking successive dots :
670 FOR f=2 TO dots
680 REMark a,b & c refer to three successive dots :
690 a=f-1: b=a+1: c=b+1: bx=t(b,x): by=t(b,y): cx=t(c,x): cy=t(c,y)
700 ax=t(a,x): ay=t(a,y)
710 abx=ax-bx: aby=ay-by: BCx=bx-cx: BCy=by-cy: acx=ax-cx: acy=ay-cy
720 as=SQRT(ax*ax+ay*ay): bs=SQRT(bx*bx+by*by): cs=SQRT(cx*cx+cy*cy)
730 IF 0<>(2*a*b): NC=ACOS((-(c*c-a*a-b*b)/(2*a*b))): ELSE NC=ACOS(0)
740 TRg(f)=NC
750 END FOR f: TRg(f+1)=TRg(f)
760 :
770 REMark Loop to determine how three successive dots are positioned :
780 FOR f=2 TO dots-5
790 omm=-9999: OVER 0
800 :
810 REMark See if angle is clockwise or anticlockwise :
820 t$=t(f,typ): CWs=t$ INSTR('06'): ACWs=t$ INSTR('28')
830 IF CWs THEN
840    IF pic(f,1)=2: t(f,typ)=3    : REMark half of a 'straightish' line.
850    IF pic(f+1,1)=3: t(f+1,typ)=1: REMark        idem
860 END IF
870 IF ACWs THEN
880    IF pic(f,1)=2: t(f,typ)=5    : REMark        idem
890    IF pic(f+1,1)=3: t(f+1,typ)=7: REMark        idem
900 END IF
910 INK 4
920 a=f-1: b=a+1: c=b+1: tipes=t(f,typ): bx=t(b,x): by=t(b,y): cx=t(c,x): cy=t(c,y)
930 REMark M indicates the mid-point :
940 BCx=bx-cx: BCy=by-cy: MCx=BCx/2: MCy=BCy/2: Mx=bx-MCx: My=by-MCy
950 REMark determine the azimuth of the bisextrice :
960 ab=t(b,azt): a1=(t(a,azt)+ab)/2: a2=(ab+t(c,azt))/2: a3=ab+Ph
970 POINT bx,by
980 :
990 REMark Matrix 'L' holds the coordinates for each curve-type :::::::::
1000 SELect ON tipes
1010 =0,3,7,8: L(1,1,x)=bx+COS(a1): L(1,1,y)=by+SIN(a1): L(1,4,x)=cx+COS(a2)
1020  L(1,4,y)=cy+SIN(a2): L(1,2,x)=bx: L(1,2,y)=by: L(1,3,x)=cx: L(1,3,y)=cy
1030 END SELect
1040 SELect ON tipes
1050 =1,2,6,7: L(2,1,x)=bx+COS(a1): L(2,1,y)=by+SIN(a1): L(2,4,x)=Mx+COS(a3)
1060 L(2,4,y)=My+SIN(a3): L(2,2,x)=bx: L(2,2,y)=by: L(2,3,x)=Mx: L(2,3,y)=My
1070 END SELect
1080 SELect ON tipes
1090 =2,3,5,6: L(3,1,x)=Mx+COS(a3): L(3,1,y)=My+SIN(a3): L(3,4,x)=cx+COS(a2)
1100 L(3,4,y)=cy+SIN(a2):  L(3,2,x)=Mx: L(3,2,y)=My: L(3,3,x)=cx: L(3,3,y)=cy
1110 END SELect
1120 : rc=10
1130 REMark determine which triangle(s) to choose for each curve type:
1140 SELect ON tipes
1150  =0: TRI 1,0
1160  =1: TRI 2,0: ARC TO t(f+1,x),t(f+1,y),-PI/rc
1170  =2: TRI 2,0: TRI 3,1
1180  =3: ARC TO Mx,My,+PI/rc: TRI 3,0
1190  =4: REMark not implemented yet.
1200  =5: ARC TO Mx,My,+PI/rc: TRI 3,1
1210  =6: TRI 2,1: TRI 3,0
1220  =7: TRI 2,1: ARC TO t(f+1,x),t(f+1,y),-PI/rc
1230  =8: TRI 1,1
1240 END SELect
1250 END FOR f : REMark LINE TO t(3,x),t(3,y): REMark only for closed loops !
1260 END DEFine DRAW
1270 :
1280 DEFine PROCedure TRI(TR,CW)
1290 REMark Find perpendicular cut-points using simultaneous equations :
1300 xa=L(TR,1,x):ya=L(TR,1,y): xb=L(TR,2,x): yb=L(TR,2,y): xc=L(TR,3,x):yc=L(TR,3,y)
1310 xd=L(TR,4,x):yd=L(TR,4,y): BCx=xb-xc: BCy=yb-yc: MCx=BCx/2: MCy=BCy/2: Mx=xb-MCx
1320 REMark use simultaneous equations to determine cut-points of bisextrices :
1330 px=xa-xb: py=ya-yb: xq=xc-xd: qy=yc-yd: g1=1E-6: g2=1E-6
1340 IF px=0: px=1E-6: END IF : g1=py/px
1350 IF xq=0: xq=1E-6: END IF : g2=qy/xq
1360 k1=ya-xa*g1: k2=yc-xc*g2: gg=g1-g2: My=yb-MCy
1370 :: IF gg=0: gg=1E-6: END IF : ix=(k2-k1)/gg: iy=g1*ix+k1
1380 Maj=SQRT(MCx*MCx+MCy*MCy): REMark Major axis of ellipse.
1390 IF TR=2: ix=(ix+bx)/2: iy=(iy+by)/2
1400 IF TR=3: ix=(ix+cx)/2: iy=(iy+cy)/2
1410 :
1420 REMark find 'projective parameters' for each elliptic arc :
1430 mix=ix-Mx: miy=iy-My: im=SQRT(mix*mix+miy*miy): Min=Maj*fc: lim=2*Min
1440 bm=SQRT(BCx*BCx+BCy*BCy)/2: ibx=ix-xb: iby=iy-yb: ib=SQRT(ibx*ibx+iby*iby)
1450 dv=1E-6
1460 IF 0<>(ib*bm): dv=(bm*bm+ib*ib-im*im)/(2*ib*bm)
1470 IF ABS(dv)>=1: adv=ACOS(.9999): ELSE adv=ACOS(dv)
1480 sdv=SIN(adv): hi=ib*sdv
1490 :
1500 REMark determine ellipse eccentricity.
1510 IF lim<>0: ec=hi/lim: ELSE ec=hi/1E-6
1520 sl=TR
1530 SELect ON sl: =1: xE=Mx: yE=My: =2: xE=bx: yE=by: =3: xE=cx: yE=cy
1540 IF hi>lim THEN
1550   IF hi<>0: ek=lim/hi: ELSE ek=lim/1E-6
1560   xx=ek*mix: Ey=ek*miy: ix=xE+xx: iy=yE+Ey: ec=fc
1570 END IF
1580 ect=(TRg(f+1))*ec
1590 IF Maj<>0: ecc=(Min/Maj)*(Min/Maj)*ect*fc: ELSE ecc=1E-6*ect*fc
1600  REMark IF ecc<3E-2: ecc=3E-2
1610 ELIPTICS
1620 END DEFine TRI
1630 :
1640 DEFine PROCedure ELIPTICS
1650 LOCal f,j,ct: ro=0: h=prec: IF xc<xb: ro=180
1660 REMark
1670 q=h+1: IF h<>0: st=360/h: ELSE st=360/1E-6
1680 IF MCx<>0: rot=DEG(ATAN(MCy/MCx)): ELSE rot=DEG(ATAN(MCy/1E-6))
1690 rot=rot+ro: h=prec: hh=h/2: rot=RAD(rot): ct=0
1700 :
1710 REMark Swing all interpolated points around cut-points:
1720 SS=-st: AA=180-st: ZZ=st*0: IF CW=0: SS=st: AA=-180+st: ZZ=-ZZ*0: ct=hh
1730 FOR f=AA TO ZZ STEP SS
1740     REMark IF f=90 OR f=-90: dud=f: REM not yet implemented
1750     ct=ct+1: j=RAD(f): Crx=Maj*COS(j)
1760     ROTATE pp,Crx,0: cry=Maj*SIN(j)*ecc: ROTATE ee,Crx,cry
1770 END FOR f
1780 :
1790 REMark Draw all curve segments linking elliptic dots :
1800 IF CW<>0: j=0: ct=hh: ELSE : j=hh: ct=h
1810 x1=ix: y1=iy
1820 FOR f=j+1 TO j+hh
1830  x2=u(2,f,x): y2=u(2,f,y): x3=u(1,f,x): y3=u(1,f,y): x4=u(1,ct,x): y4=u(1,ct,y)
1840  xp=x1-x2: yp=y1-y2: xq=x3-x4: yq=y3-y4: IF xp<>0: g1=yp/xp: ELSE g1=yp/1E-6
1850  IF xq<>0: g2=yq/xq: ELSE g2=yq/1E-6
1860  k1=y1-x1*g1: gg=g1-g2: IF gg=0: gg=1E-6: END IF : m=(y3-x3*g2-k1)/gg
1870  n=g1*m+k1:  IF 0==(xp+1): m=x1: n=y3+g2*(x1-x3)
1880              IF 0==(xq+1): m=x3: n=y1+g1*(x3-x1)
1890  LINE TO m,n: IF pr: INK 7: CIRCLE m,n,1.8: INK 4
1900 ct=ct-1
1910 END FOR f
1920 END DEFine ELIPTICS
1930 :
1940 DEFine PROCedure ROTATE(nn,rx,ry)
1950 LOCal rh,a,b,c,d,h,n,r
1960 REMark projectional rotation using correct sign types :
1970 c=(rx>0)-(rx<0): d=(ry>0)-(ry<0):n=-1
1980 h=SQRT(rx*rx+ry*ry)
1990 IF h=0: h=1E-6
2000 ryh=ry/h: IF 1==ABS(ryh): ryh=1
2010 a=ABS(ASIN(ryh))
2020 SELect ON c
2030 =-1: SELect ON d: =-1: a=PI+a: =0: a=PI: =+1: a=PI-a
2040 =0 : SELect ON d: =-1: a=Pl  : =0: a=0 : =+1: a=Ph
2050 =+1: SELect ON d: =-1: a=Pww-a: =0: a=0 : =+1: a=a
2060 END SELect : b=a+rot: c=1: d=1: xx=0: yy=0
2070 REPeat r: IF b<0: b=b+Pww: ELSE EXIT r
2080 IF b>=Pww:b=b-Pww: GO TO 2080
2090 IF (0==(b+1)) OR (b==Pww): xx=h:  GO TO 2140
2100 IF b>Pl : b=Pww-b : d=n: GO TO 2140
2110 IF b==PI: xx=-h  : GO TO 2140
2120 IF b==Pl: yy=-h: GO TO 2140
2130 IF b>PI : b=b-PI: c=n: d=n
2140 xx=h*COS(b)*c: yy=h*SIN(b)*d
2150 u(nn,ct,x)=Mx+xx: u(nn,ct,y)=My+yy
2160 END DEFine
2170 :
2180 DEFine PROCedure INIT
2190 WINDOW 512,256,0,0: SCALE 256,-148,-128: PAPER 0: INK 7: CLS
2200 WINDOW#2,512,206,0,0
2210 sg$='++ +0 +- 0+ 00 0- -+ -0 -- ': sig$='-0+'
2220 x=1: y=2: azt=3: trn=4: typ=5: Ph=PI/2: Pl=Ph*3: Pww=PI*2: ee=1: pp=2
2230 dots=dotss+5: DIM t(dots+5,typ),L(3,4,2),u(pp,prec,y): fc=.7
2240 t(0,x)=-180: t(0,y)=0: REMark (Fictive closed-loop starting point).
2250 : fx=512/dotss: fy=256/dotss*7: AT 0,1: PRINT dots-5,prec,: INK 2
2260 :
2270 REMark here is the program's 'point data' :
2280 FOR f=1 TO dots: t(f,x)=t(f-1,x)+fx
2290 FOR f=1 TO dots: t(f,y)=(t(f-1,y)+RND(fy)-RND(fy))+1
2300 :
2320 IF dotss=4: dots=10: RESTORE : CIRCLE 0,0,56: READ t(0,x),t(0,y): FOR f=1 TO 4+5: READ t(f,x),t(f,y): END FOR f
2330 DATA -40,-40,-40,40,40,40,40,-40, -40,-40,-40,40,40,40,40,-40, -40,-40,-40,40,40,40,-40, -40,-40
2340 :
2350 REMark Horizontal or vertical lines are 'nudged' :
2360 FOR f=2 TO dots: IF t(f,x)=t(f-1,x): t(f,x)=t(f,x)+1E-6
2370 FOR f=2 TO dots: IF t(f,y)=t(f-1,y): t(f,y)=t(f,y)+1E-6
2380 :
2390 REMark Determine auto-scaling parameters:
2400 Min=99999: FOR f=1 TO dots: IF t(f,y)<Min: Min=t(f,y)
2410 Maj=-9999: FOR f=1 TO dots: IF t(f,y)>Maj: Maj=t(f,y)
2420  IF dotss>4:  sca=(Maj+ABS(Min)): SCALE sca*2,t(1,x),-sca
2430 :
2440 REMark Draw the dots:
2450 FOR f=2 TO dots-4: FILL 1: CIRCLE t(f,x),t(f,y),5: FILL 0
2460 :
2470 REMark Allow array space for closed loops:
2480 IF dotss>4: FOR f=1 TO 4: t(f+dots,x)=t(f,x): t(f+dots,y)=t(f,y)
2490 END DEFine
2500 :
